Bug 2142671 - Review Request: lua-cosmo - Safe templates for Lua
Summary: Review Request: lua-cosmo - Safe templates for Lua
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Arthur Bols
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 2149698
TreeView+ depends on / blocked
 
Reported: 2022-11-14 20:18 UTC by Jonny Heggheim
Modified: 2022-12-15 02:16 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2022-12-07 15:26:50 UTC
Type: ---
Embargoed:
arthur: fedora-review+


Attachments (Terms of Use)

Description Jonny Heggheim 2022-11-14 20:18:01 UTC
Spec URL: https://jonny.fedorapeople.org/lua-cosmo.spec
SRPM URL: https://jonny.fedorapeople.org/lua-cosmo-16.06.04-1.fc36.src.rpm

Description:
Cosmo is a "safe templates" engine. It allows you to fill nested templates,
providing many of the advantages of Turing-complete template engines,
without without the downside of allowing arbitrary code in the templates.

Fedora Account System Username: jonny

Comment 1 Jonny Heggheim 2022-11-14 20:18:04 UTC
This package built on koji:  https://koji.fedoraproject.org/koji/taskinfo?taskID=94180175

Comment 2 Jonny Heggheim 2022-11-15 22:26:33 UTC
A dependency for SILE https://sile-typesetter.org/

Comment 3 Arthur Bols 2022-12-05 14:44:20 UTC
I think it's a bit strange to include a separate license file. In this case it would be fine to include the cosmo.md file in %license. 
It's a bit cumbersome that the file would be missing from %doc. You could create a symlink so that the %license file points to cosmo.md in %doc.

Please change the versioned requires for lua-lpeg to unversioned. The oldest version available is 0.12 in el7, so the requirement would always be met. See https://docs.fedoraproject.org/en-US/packaging-guidelines/#_package_dependencies


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT License", "Unknown or generated". 21 files have unknown
     license. Detailed output of licensecheck in /home/arthur/fedora-
     review/2142671-lua-cosmo/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 30720 bytes in 3 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[!]: Package does not include license text files separate from upstream.

     See remark above

[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Cannot parse rpmlint output:


Rpmlint (installed packages)
----------------------------
============================ rpmlint session starts ============================
rpmlint: 2.4.0
configuration:
    /usr/lib/python3.11/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
checks: 31, packages: 1

 1 packages and 0 specfiles checked; 0 errors, 0 warnings, 0 badness; has taken 0.0 s 



Source checksums
----------------
https://github.com/mascarenhas/cosmo/archive/v16.06.04/cosmo-16.06.04.tar.gz :
  CHECKSUM(SHA256) this package     : 86d17aea5080a90671d965cffeb9b104c19e0e1ea55c08687c0924c4512b52b1
  CHECKSUM(SHA256) upstream package : 86d17aea5080a90671d965cffeb9b104c19e0e1ea55c08687c0924c4512b52b1


Requires
--------
lua-cosmo (rpmlib, GLIBC filtered):
    lua(abi)
    lua-lpeg



Provides
--------
lua-cosmo:
    lua-cosmo



Generated by fedora-review 0.9.0 (6761b6c) last change: 2022-08-23
Command line :/usr/bin/fedora-review -b 2142671
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, fonts, Haskell, C/C++, Perl, SugarActivity, Ocaml, R, Python, PHP
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 4 Jonny Heggheim 2022-12-05 20:58:19 UTC
Updated the spec+srpm with same URL:

Spec URL: https://jonny.fedorapeople.org/lua-cosmo.spec
SRPM URL: https://jonny.fedorapeople.org/lua-cosmo-16.06.04-1.fc36.src.rpm

I was not sure how to include the %license, I probably started on including a separate license file and probably found out later that it was inlined in the documentation.

 * Changed lua-lpeg to unversioned.
 * Removed the extra %license
 * Tidy the %docs 

The cosmo.md file is included twice, I am not sure how the %doc macro works, it should be possible to symlink instead to save 18KB.

Looks like this now:
$ rpm -qlv lua-cosmo
drwxr-xr-x    2 root     root                        0 Dec  5 21:50 /usr/share/doc/lua-cosmo
-rw-r--r--    1 root     root                      923 Jun  4  2016 /usr/share/doc/lua-cosmo/README
-rw-r--r--    1 root     root                    18337 Jun  4  2016 /usr/share/doc/lua-cosmo/cosmo.md
-rw-r--r--    1 root     root                     1824 Jun  4  2016 /usr/share/doc/lua-cosmo/sample.lua
drwxr-xr-x    2 root     root                        0 Dec  5 21:50 /usr/share/licenses/lua-cosmo
-rw-r--r--    1 root     root                    18337 Jun  4  2016 /usr/share/licenses/lua-cosmo/cosmo.md
drwxr-xr-x    2 root     root                        0 Dec  5 21:50 /usr/share/lua/5.4/cosmo
-rw-r--r--    1 root     root                    10172 Dec  5 21:50 /usr/share/lua/5.4/cosmo.lua
-rw-r--r--    1 root     root                     4337 Dec  5 21:50 /usr/share/lua/5.4/cosmo/fill.lua
-rw-r--r--    1 root     root                     5049 Dec  5 21:50 /usr/share/lua/5.4/cosmo/grammar.lua


$ ls -lah /usr/share/licenses/lua-cosmo/cosmo.md /usr/share/doc/lua-cosmo/cosmo.md
.rw-r--r--. root root 18 KB Sat Jun  4 20:59:21 2016  /usr/share/licenses/lua-cosmo/cosmo.md
.rw-r--r--. root root 18 KB Sat Jun  4 20:59:21 2016  /usr/share/doc/lua-cosmo/cosmo.md

Comment 5 Arthur Bols 2022-12-06 07:54:48 UTC
Thanks! %doc and %license just copy the files. You could do something like this: https://principis.fedorapeople.org/lua-cosmo.spec 

I noticed you've removed the index.html from %doc, was this by mistake? I believe it's redundant so it should be fine to leave it out.

Comment 6 Jonny Heggheim 2022-12-06 12:00:29 UTC
> You could do something like this: https://principis.fedorapeople.org/lua-cosmo.spec 

I feel that is getting too hackish and harder to maintain.

> ln -s ../../doc/%{name}/cosmo.md LICENSE.md

For me it does not make sense why %buildroot is not used in the %install section. The doc location is now hard-coded instead of a macro. 
If the user install with --nodocs flag, then the %license link is dangling.

> I noticed you've removed the index.html from %doc, was this by mistake? I believe it's redundant so it should be fine to leave it out.

I had a look and noticed that they were the "same", but after some thinking I lean towards that it is best to do the same as opensuse:

> %license %{luarocks_treedir}/%{mod_name}/%{rock_version}/doc/cosmo.md
> %docdir %{luarocks_treedir}/%{mod_name}/%{rock_version}/doc

https://build.opensuse.org/package/view_file/devel:languages:lua/lua-cosmo/lua-cosmo.spec?expand=1

Include all files documentation in the doc folder, since upstream have included it in their repo and published it on luarocks.

Comment 7 Jonny Heggheim 2022-12-06 12:00:57 UTC
Updated the spec+srpm:

Spec URL: https://jonny.fedorapeople.org/lua-cosmo.spec
SRPM URL: https://jonny.fedorapeople.org/lua-cosmo-16.06.04-1.fc36.src.rpm

Comment 8 Arthur Bols 2022-12-06 12:50:21 UTC
You right, that hadn't occurred to me. I asked for feedback on #fedora-devel because I wasn't quite sure what to do with it, but I hadn't received an answer yet.
It's only a small nitpick anyway.

Everything looks good, Package APPROVED.

Comment 9 Jonny Heggheim 2022-12-06 13:03:32 UTC
I think it is good with feedback and discussion on corner cases where we can try to find the best solution.

Again, thanks for all the reviews.

Comment 10 Gwyn Ciesla 2022-12-06 14:22:38 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/lua-cosmo

Comment 11 Fedora Update System 2022-12-06 15:00:56 UTC
FEDORA-2022-d6f4177eba has been submitted as an update to Fedora 36. https://bodhi.fedoraproject.org/updates/FEDORA-2022-d6f4177eba

Comment 12 Fedora Update System 2022-12-06 15:01:14 UTC
FEDORA-2022-6109861645 has been submitted as an update to Fedora 37. https://bodhi.fedoraproject.org/updates/FEDORA-2022-6109861645

Comment 13 Fedora Update System 2022-12-07 02:50:35 UTC
FEDORA-2022-6109861645 has been pushed to the Fedora 37 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --refresh --advisory=FEDORA-2022-6109861645 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2022-6109861645

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 14 Fedora Update System 2022-12-07 03:03:52 UTC
FEDORA-2022-d6f4177eba has been pushed to the Fedora 36 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --refresh --advisory=FEDORA-2022-d6f4177eba \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2022-d6f4177eba

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 15 Jonny Heggheim 2022-12-07 15:26:50 UTC
Updated for Fedora 36

Comment 16 Fedora Update System 2022-12-15 01:42:32 UTC
FEDORA-2022-6109861645 has been pushed to the Fedora 37 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 17 Fedora Update System 2022-12-15 02:16:53 UTC
FEDORA-2022-d6f4177eba has been pushed to the Fedora 36 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.